function FarmTruckvehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		//If a signal is on, that side will be left alone

		if(%veh.signal < 1)		//Don't touch the taillight if the turn signal is on
		{
			%veh.hidenode(lights_brakeR_0);
			%veh.hidenode(lights_brakeR_1);
			%veh.unhidenode(lights_brakeR_2);
		}
		if(%veh.signal > -1)
		{
			%veh.hidenode(lights_brakeL_0);
			%veh.hidenode(lights_brakeL_1);
			%veh.unhidenode(lights_brakeL_2);
		}
	}
	else
	{	//brake off
		%veh.braking = 0;


		if(%veh.signal < 1)
		{
			%veh.hidenode(lights_brakeR_2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeR_0);

			else
				%veh.unhidenode(lights_brakeR_1);
		}
		if(%veh.signal > -1)
		{
			%veh.hidenode(lights_brakeL_2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeL_0);

			else
				%veh.unhidenode(lights_brakeL_1);
		}
	}
}

function FarmTruckvehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 2)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			// %veh.mountedLightBot[4].setMountedLight(none);
			%veh.unhidenode(lights_whiteOUT_0);
			%veh.unhidenode(lights_amberL_0);
			%veh.unhidenode(lights_amberR_0);
			%veh.unhidenode(dashlight_off);

			%veh.hidenode(dashlight_on);
			%veh.hidenode(lights_whiteOUT_1);
			%veh.hidenode(lights_amberL_1);
			%veh.hidenode(lights_amberR_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal < 1)
				{
					%veh.hidenode(lights_brakeR_2);
					%veh.hidenode(lights_brakeR_1);
					%veh.unhidenode(lights_brakeR_0);
				}
				if(%veh.signal > -1)
				{
					%veh.hidenode(lights_brakeL_2);
					%veh.hidenode(lights_brakeL_1);
					%veh.unhidenode(lights_brakeL_0);
				}
			}
		
		case 1:		//Daytime-running lights
			%veh.unhidenode(lights_whiteOUT_1);
			%veh.unhidenode(lights_amberL_1);
			%veh.unhidenode(lights_amberR_1);
			%veh.unhidenode(dashlight_on);

			%veh.hidenode(dashlight_off);
			%veh.hidenode(lights_whiteOUT_0);
			%veh.hidenode(lights_amberL_0);
			%veh.hidenode(lights_amberR_0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal < 1)
				{
					%veh.hidenode(lights_brakeR_2);
					%veh.hidenode(lights_brakeR_0);
					%veh.unhidenode(lights_brakeR_1);
				}
				if(%veh.signal > -1)
				{
					%veh.hidenode(lights_brakeL_2);
					%veh.hidenode(lights_brakeL_0);
					%veh.unhidenode(lights_brakeL_1);
				}
			}
		
		case 2:		//Full lights including light source
			// %veh.mountedLightBot[4].setMountedLight(FarmTruckHeadLight);
			
			%veh.hidenode(lights_whiteOUT_0);
			%veh.hidenode(lights_amberL_0);
			%veh.hidenode(lights_amberR_0);
			%veh.hidenode(dashlight_off);

			%veh.unhidenode(dashlight_on);
			%veh.unhidenode(lights_whiteOUT_1);
			%veh.unhidenode(lights_amberL_1);
			%veh.unhidenode(lights_amberR_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal < 1)
				{
					%veh.hidenode(lights_brakeR_2);
					%veh.hidenode(lights_brakeR_0);
					%veh.unhidenode(lights_brakeR_1);
				}
				if(%veh.signal > -1)
				{
					%veh.hidenode(lights_brakeL_2);
					%veh.hidenode(lights_brakeL_0);
					%veh.unhidenode(lights_brakeL_1);
				}
			}
	}
}


/////////////////////////////////////////////////////////////////////////////////


package FarmTruckTurnSignalsShiftBrick
{
	function serverCmdShiftBrick(%client, %x, %y, %z)	//Brick shift controls
	{
		if(isObject(%pl = %client.player) && isObject(%veh = %pl.getObjectMount()))	//Player & mounted vehicle exist
		{
			%data = %veh.getDataBlock();
			if(%data.hasTurnSignals && %pl.getMountNode() == 0)	//Driver of a vehicle with these turn signals
			{
				if(%y == 1)							//Shift brick left
				{
					if(%veh.signal == -1)
						return %data.turnSignal(%veh, 0);
					else if(%veh.signal == 0)
						return %data.turnSignal(%veh, -1);
					else
					{
						%data.turnSignal(%veh, 0);
						%data.turnSignal(%veh, -1);
						return;
					}
				}
					
				else if(%y == -1)					//Shift brick right
				{
					if(%veh.signal == 1)
						return %data.turnSignal(%veh, 0);
					else if(%veh.signal == 0)
						return %data.turnSignal(%veh, 1);
					else
					{
						%data.turnSignal(%veh, 0);
						%data.turnSignal(%veh, 1);
						return;
					}
				}
			}
		}
		parent::serverCmdShiftBrick(%client, %x, %y, %z);
	}
};
activatePackage(FarmTruckTurnSignalsShiftBrick);

function FarmTruckVehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	%veh.signal = %direction;	//Other functions must know which direction is being used

	if(%direction == 0)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used
		%veh.hideNode(lights_analog_up);
		%veh.unhideNode(lights_analog_mid);
		%veh.hideNode(lights_analog_down);

		if(%veh.braking)				//If the car is braking, return taillights to bright red
		{
			%veh.hidenode(lights_brakeR_0);
			%veh.hidenode(lights_brakeL_0);
			%veh.hidenode(lights_brakeR_1);
			%veh.hidenode(lights_brakeL_1);
			%veh.unhidenode(lights_brakeR_2);
			%veh.unhidenode(lights_brakeL_2);
		}
		else if(%veh.headlightState == 0)	//If no brakes and lights are off, return taillights to completely off
		{
			%veh.unhidenode(lights_brakeR_0);
			%veh.unhidenode(lights_brakeL_0);
			%veh.hidenode(lights_brakeR_1);
			%veh.hidenode(lights_brakeL_1);
			%veh.hidenode(lights_brakeR_2);
			%veh.hidenode(lights_brakeL_2);
		}
		else							//If no brakes and lights are on, return taillights to dim red
		{
			%veh.hidenode(lights_brakeR_0);
			%veh.hidenode(lights_brakeL_0);
			%veh.unhidenode(lights_brakeR_1);
			%veh.unhidenode(lights_brakeL_1);
			%veh.hidenode(lights_brakeR_2);
			%veh.hidenode(lights_brakeL_2);
		}


		if(%veh.headlightState == 0)
		{
			%veh.unhideNode(lights_amberR_0);
			%veh.unhideNode(lights_amberL_0);
			%veh.hideNode(lights_amberR_1);
			%veh.hideNode(lights_amberL_1);
		}
		else
		{
			%veh.hideNode(lights_amberR_0);
			%veh.hideNode(lights_amberL_0);
			%veh.unhideNode(lights_amberR_1);
			%veh.unhideNode(lights_amberL_1);
		}
		return;
	}	//END OF TURN OFF SIGNAL

	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			%veh.hideNode(lights_amberR_0);
			%veh.unhideNode(lights_amberR_1);
			%veh.unhideNode(lights_analog_up);
			%veh.hideNode(lights_analog_mid);
			%veh.hideNode(lights_analog_down);

			%veh.hideNode(lights_brakeR_0);
			%veh.hideNode(lights_brakeR_1);
			%veh.unhideNode(lights_brakeR_2);
		}
		else					//Left side turn on
		{
			%veh.hideNode(lights_amberL_0);
			%veh.unhideNode(lights_amberL_1);
			%veh.hideNode(lights_analog_up);
			%veh.hideNode(lights_analog_mid);
			%veh.unhideNode(lights_analog_down);

			%veh.hideNode(lights_brakeL_0);
			%veh.hideNode(lights_brakeL_1);
			%veh.unhideNode(lights_brakeL_2);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{
			%veh.unhideNode(lights_amberR_0);
			%veh.hideNode(lights_amberR_1);

			%veh.hideNode(lights_brakeR_2);

			if(%veh.headlightState > 0) %veh.unhideNode(lights_brakeR_1);
			else                        %veh.unhideNode(lights_brakeR_0);
		}
		else					//Left side turn off
		{
			%veh.unhideNode(lights_amberL_0);
			%veh.hideNode(lights_amberL_1);

			%veh.hideNode(lights_brakeL_2);

			if(%veh.headlightState > 0)
			{
				%veh.unhideNode(lights_brakeL_1);
			}
			else
			{
				%veh.unhideNode(lights_brakeL_0);
			}
		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(333, turnSignal, %veh, %direction);
}