datablock TSShapeConstructor(FarmTruckDts)
{
	baseShape = "./shapes/FarmTruck.dts";
	sequence0 = "./shapes/steering.dsq steering";
	sequence1 = "./shapes/doorL_Open.dsq ldOpen";
	sequence2 = "./shapes/doorL_Close.dsq ldClose";
	sequence3 = "./shapes/doorR_Open.dsq rdOpen";
	sequence4 = "./shapes/doorR_Close.dsq rdClose";
	sequence5 = "./shapes/hood_Open.dsq hOpen";
	sequence6 = "./shapes/hood_Close.dsq hClose";
	sequence7 = "./shapes/tailgate_Open.dsq tgOpen";
	sequence8 = "./shapes/tailgate_Close.dsq tgClose";
};  

datablock fxLightData(FarmTruckHeadLight)
{
	radius = 45;
	brightness = 3.3;
	color = "1 0.85 0.55 1";
	flareOn = false;
};

// Vehicle //
/////////////

datablock WheeledVehicleData(FarmTruckVehicle) 
{
    category = "Vehicles";
    displayName = " ";
    shapeFile = "./shapes/FarmTruck.dts"; //"~/data/shapes/skivehicle.dts"; //
    emap = true;
    minMountDist = 3;

    numMountPoints = 4;
    mountThread[0] = "sit";
    mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

    maxDamage = 200.00;
    destroyedLevel = 200.00;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier = 0.02;

    massCenter = "0 -0.2 -0.6";
    //massBox = "2 5 1";

    maxSteeringAngle = 0.7980;//0.9785 // Maximum steering angle, should match animation
    integration = 4; // Force integration time: TickSec/Rate

    // 3rd person camera settings
    cameraRoll = false; // Roll the camera with the vehicle
    cameraMaxDist = 13; // Far distance from vehicle
    cameraOffset = 7.5; // Vertical offset from camera mount point
    cameraLag = 0.0; // Velocity lag of camera
    cameraDecay = 0.75; // Decay per sec. rate of velocity lag
    cameraTilt = 0.4;
    collisionTol = 0.1; // Collision distance tolerance
    contactTol = 0.1;

    useEyePoint = false;

    defaultTire = FarmTruckFrontTire;
    defaultSpring = FarmTruckSpring;
    //flatTire	= FarmTruckFlatTire;
    //flatSpring	= FarmTruckFlatSpring;

    numWheels = 4;

    // Rigid Body
    mass = 300;
    density = 5.0;
    drag = 1.6;
    bodyFriction = 0.6;
    bodyRestitution = 0.6;
    minImpactSpeed = 10; // Impacts over this invoke the script callback
    softImpactSpeed = 10; // Play SoftImpact Sound
    hardImpactSpeed = 15; // Play HardImpact Sound
    groundImpactMinSpeed = 10.0;

    // Engine
    engineTorque = 6000; //4000;       // Engine power
    engineBrake = 400; // Braking when throttle is 0
    brakeTorque = 5000; // When brakes are applied
    maxWheelSpeed = 30; // Engine scale by current speed / max speed

    rollForce = 900;
    yawForce = 600;
    pitchForce = 1000;
    rotationalDrag = 0.2;

    // Advanced Steering
    steeringAutoReturn = true;
    steeringAutoReturnRate = 0.9;
    steeringAutoReturnMaxSpeed = 10;
    steeringUseStrafeSteering = true;
    steeringStrafeSteeringRate = 0.1;

    // Energy
    maxEnergy = 100;
    jetForce = 3000;
    minJetEnergy = 30;
    jetEnergyDrain = 2;

    splash = vehicleSplash;
    splashVelocity = 4.0;
    splashAngle = 67.0;
    splashFreqMod = 300.0;
    splashVelEpsilon = 0.60;
    bubbleEmitTime = 1.4;
    splashEmitter[0] = vehicleFoamDropletsEmitter;
    splashEmitter[1] = vehicleFoamEmitter;
    splashEmitter[2] = vehicleBubbleEmitter;
    mediumSplashSoundVelocity = 10.0;
    hardSplashSoundVelocity = 20.0;
    exitSplashSoundVelocity = 5.0;

    //mediumSplashSound = "";
    //hardSplashSound = "";
    //exitSplashSound = "";

    //Sounds
    //jetSound = ScoutThrustSound;
    //engineSound = idleSound;
    //squealSound = skidSound;
    softImpactSound = slowImpactSound;
    hardImpactSound = fastImpactSound;
    //wheelImpactSound = slowImpactSound;

    //explosion = VehicleExplosion;
    justcollided = 0;

    uiName = "Farm Truck";
    rideable = true;
    lookUpLimit = 0.51;
    lookDownLimit = 0.51;

    paintable = true;

	handsOnVehicle = 1;
	hasScriptedHeadlights = 1;
	hasTurnSignals = 1;
	isFarmTruckVehicle = 1;
	
	//- Interactive Definitions -
	isInteractive = true;
	iNumZones = 4;
	iZone[0] = "-30 -2 1 -1.3 0.6 1.8";
	iZoneScript[0] = "onLeftDoor";
	iZone[1] = "-5 -0.9 0.6 -1.3 0.6 1.8";
	iZoneScript[1] = "onRightDoor";
	iZone[2] = "-5 -0.9 0.6 -1.3 0.6 1.8";
	iZoneScript[2] = "onHood";
	iZone[3] = "-1 -5 -0.4 1.4 -4 0.4";
	iZoneScript[3] = "onTailgate";

    damageEmitter[0] = VehicleBurnEmitter;
    damageEmitterOffset[0] = "0.0 0.0 0.0 ";
    damageLevelTolerance[0] = 0.99;

    damageEmitter[1] = VehicleBurnEmitter;
    damageEmitterOffset[1] = "0.0 0.0 0.0 ";
    damageLevelTolerance[1] = 1.0;

    numDmgEmitterAreas = 1;

    initialExplosionProjectile = FarmTruckExplosionProjectile;
    initialExplosionOffset = 0; //offset only uses a z value for now

    burnTime = 4000;

    finalExplosionProjectile = FarmTruckProjectile;
    finalExplosionOffset = 0.5; //offset only uses a z value for now

    minRunOverSpeed = 4; //how fast you need to be going to run someone over (do damage)
    runOverDamageScale = 8; //when you run over someone, speed * runoverdamagescale = damage amt
    runOverPushScale = 1.2; //how hard a person you're running over gets pushed

    //protection for passengers
    protectPassengersBurn = false; //protect passengers from the burning effect of explosions?
    protectPassengersRadius = true; //protect passengers from radius damage (explosions) ?
    protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

//initial FarmTruck explosion, FarmTruck loses wheels and is burned
//  we use the default vehicle explosion, but add wheels debris
// Explosion
////////////

datablock ExplosionData(FarmTruckExplosion: vehicleExplosion) 
{
    debris = FarmTruckTireDebris;
    debrisNum = 4;
    debrisNumVariance = 0;
    debrisPhiMin = 0;
    debrisPhiMax = 360;
    debrisThetaMin = 40;
    debrisThetaMax = 85;
    debrisVelocity = 14;
    debrisVelocityVariance = 3;
};

// Projectile - you can't spawn explosions on the server, so we use a short-lived projectile
/////////////////////////////////

datablock ProjectileData(FarmTruckExplosionProjectile: vehicleExplosionProjectile) 
{
    directDamage = 0;
    radiusDamage = 0;
    damageRadius = 0;
    explosion = FarmTruckExplosion;

    directDamageType = $DamageType::VehicleExplosion;
    radiusDamageType = $DamageType::VehicleExplosion;

    explodeOnDeath = 1;

    armingDelay = 0;
    lifetime = 0;

    uiName = "Farm Truck Explosion";
};

// FarmTruck explodes and throws one huge debris chunk of itself
//  we use the default vehicle final explosion, but add FarmTruck-shaped debris

// Debris trail emitter
////////////////////////

datablock ParticleData(FarmTruckDebrisTrailParticle) 
{
    dragCoefficient = 3.0;
    windCoefficient = 0.0;
    gravityCoefficient = -0.5;
    inheritedVelFactor = 0.0;
    constantAcceleration = 0.0;
    lifetimeMS = 600;
    lifetimeVarianceMS = 150;
    spinSpeed = 10.0;
    spinRandomMin = -50.0;
    spinRandomMax = 50.0;
    useInvAlpha = true;
    animateTexture = false;
    //framesPerSec		= 1;

    textureName = "base/data/particles/cloud";
    //animTexName		= "~/data/particles/cloud";

    // Interpolation variables
    colors[0] = "0.0 0.0 0.0 0.5";
    colors[1] = "0.0 0.0 0.0 1.0";
    colors[2] = "0.0 0.0 0.0 0.0";

    sizes[0] = 2.0;
    sizes[1] = 5.0;
    sizes[2] = 5.0;

    times[0] = 0.0;
    times[1] = 0.1;
    times[2] = 1.0;
};

datablock ParticleEmitterData(FarmTruckDebrisTrailEmitter) 
{
    ejectionPeriodMS = 15;
    periodVarianceMS = 0;
    ejectionVelocity = 8;
    velocityVariance = 1.0;
    ejectionOffset = 1.0;
    thetaMin = 40;
    thetaMax = 90;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvance = false;
    particles = "FarmTruckDebrisTrailParticle";

    uiName = "Farm Truck Debris Trail";
    emitterNode = FifthEmitterNode;
};

datablock DebrisData(FarmTruckDebris) 
{
    emitters = "FarmTruckDebrisTrailEmitter";

    shapeFile = "./shapes/FarmTruckWreckage.dts";
    lifetime = 3.0;
    minSpinSpeed = -500.0;
    maxSpinSpeed = 500.0;
    elasticity = 0.5;
    friction = 0.2;
    numBounces = 1;
    staticOnMaxBounce = true;
    snapOnMaxBounce = false;
    fade = true;

    gravModifier = 2;
};

// Explosion
////////////

datablock ExplosionData(FarmTruckFinalExplosion: vehicleFinalExplosion) 
{
    debris = FarmTruckDebris;
    debrisNum = 1;
    debrisNumVariance = 0;
    debrisPhiMin = 0;
    debrisPhiMax = 360;
    debrisThetaMin = 0;
    debrisThetaMax = 20;
    debrisVelocity = 18;
    debrisVelocityVariance = 3;
};


// Projectile - you can't spawn explosions on the server, so we use a short-lived projectile
/////////////////////////////////

datablock ProjectileData(FarmTruckFinalExplosionProjectile: vehicleFinalExplosionProjectile) 
{
    directDamage = 0;
    radiusDamage = 0;
    damageRadius = 0;
    explosion = FarmTruckFinalExplosion;

    directDamageType = $DamageType::VehicleExplosion;
    radiusDamageType = $DamageType::VehicleExplosion;

    explodeOnDeath = 1;

    armingDelay = 0;
    lifetime = 0;

    uiName = "FarmTruck Final Explosion";
};

datablock WheeledVehicleSpring(FarmTruckSpring) 
{
    // Wheel suspension properties
    length = 0.4; // Suspension travel
    force = 4500; //3000;		 // Spring force
    damping = 800; //600;		 // Spring damping
    antiSwayForce = 6; //3;		 // Lateral anti-sway force
};

datablock WheeledVehicleTire(FarmTruckRearTire) 
{
    // Tires act as springs and generate lateral and longitudinal
    // forces to move the vehicle. These distortion/spring forces
    // are what convert wheel angular velocity into forces that
    // act on the rigid body.
    shapeFile = "./shapes/FarmTrucktire.dts";

    mass = 10;
    radius = 1;
    staticFriction = 3.5;
    kineticFriction = 3.5;
    restitution = 0.5;

    // Spring that generates lateral tire forces
    lateralForce = 18000;
    lateralDamping = 4000;
    lateralRelaxation = 0.01;

    // Spring that generates longitudinal tire forces
    longitudinalForce = 14000;
    longitudinalDamping = 2000;
    longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleTire(FarmTruckFrontTire) 
{
    // Tires act as springs and generate lateral and longitudinal
    // forces to move the vehicle. These distortion/spring forces
    // are what convert wheel angular velocity into forces that
    // act on the rigid body.
    shapeFile = "./shapes/FarmTrucktire.dts";

    mass = 10;
    radius = 1;
    staticFriction = 1;
    kineticFriction = 5;
    restitution = 0.5;

    // Spring that generates lateral tire forces
    lateralForce = 18000;
    lateralDamping = 4000;
    lateralRelaxation = 0.01;

    // Spring that generates longitudinal tire forces
    longitudinalForce = 14000;
    longitudinalDamping = 2000;
    longitudinalRelaxation = 0.01;
};

package FarmTruckPackage
{
	function FarmTruckVehicle::onAdd(%data, %veh)
	{
		Parent::onAdd(%data, %veh);
		
		%veh.spawnMountedLightBot(5);

		%veh.headlightState = 1;
		
		%veh.setWheelPowered(0, 0);
		%veh.setWheelPowered(1, 0);
		%veh.setWheelTire(2, FarmTruckRearTire);
		%veh.setWheelTire(3, FarmTruckRearTire);

		%veh.hidenode(lights_whiteIN_1);
		%veh.hidenode(lights_whiteOUT_1);
		%veh.hidenode(lights_amberL_1);
		%veh.hidenode(lights_amberR_1);
		%veh.hidenode(lights_brakeR_1);
		%veh.hidenode(lights_brakeR_2);
		%veh.hidenode(lights_brakeL_1);
		%veh.hidenode(lights_brakeL_2);
		%veh.hidenode(Key_On);
		%veh.hidenode(dashlight_on);
		
		%veh.hidenode(lights_analog_up);
		%veh.hidenode(lights_analog_down);
		
		%veh.hidenode(shifter_first);
		%veh.hidenode(shifter_second);
		%veh.hidenode(shifter_third);
		%veh.hidenode(shifter_fourth);
		%veh.hidenode(shifter_reverse);
	}
};

activatepackage(FarmTruckPackage);

package onDriverEnterPackage
{
	function armor::onMount(%this, %obj, %vehicle, %node)
	{
		Parent::onMount(%this, %obj, %vehicle, %node);
		
		if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
			%vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
	}

};
activatePackage(onDriverEnterPackage);

function FarmTruckVehicle::onDriverEnter(%data, %veh)
{	
	//onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
	//The hasDriver variable makes it so these things are done only one time each.
	if(!%veh.hasDriver)
	{
		%veh.hasDriver = 1;
		%veh.unhideNode(Key_On);
		%veh.hideNode(Key_Off);
		%veh.playThread(3,engine);
		
		%data.headlights(%veh, "restore");
	}
}

function FarmTruckVehicle::onDriverLeave(%data, %veh)
{		
	if(%veh.hasDriver)
	{
		%veh.hasDriver = 0;

		%veh.braking = 0;
		%veh.hidenode(lights_brakeR_2);
		%veh.hidenode(lights_brakeL_2);
		%veh.hideNode(lights_analog_up);
		%veh.unhideNode(lights_analog_mid);
		%veh.hideNode(lights_analog_down);
		%veh.hideNode(Key_On);
		%veh.unhideNode(Key_Off);
		%veh.playThread(3,engineroot);

		%data.turnSignal(%veh, 0);
		%data.headlights(%veh, "off");
	}
}

function FarmTruckVehicle::onRemove(%data, %veh)
{
	%veh.removeMountedLightBot(4);
}

package scriptedHeadlightsPackage	//misnomer
{
	function serverCmdLight(%client)
	{
		if(isObject(%pl = %client.player) && !isObject(%pl.light) && isObject(%veh = %pl.getObjectMount()) && %pl.getMountNode() == 0)
		{
			if(%veh.dataBlock.hasScriptedHeadlights)
			{
				%veh.dataBlock.headlights(%veh, "next");
				return; //do not have player's light turn on
			}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(scriptedHeadlightsPackage);

function FarmTruckVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.leftDoorTime) > 650)
        {
                %obj.leftDoorTime = %time;
                %obj.leftDoor = !%obj.leftDoor;
                %obj.playThread(0, %obj.leftDoor ? ldOpen : ldClose);
        }

        return 1;
}

function FarmTruckVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.RightDoorTime) > 650)
        {
                %obj.RightDoorTime = %time;
                %obj.RightDoor = !%obj.RightDoor;
                %obj.playThread(0, %obj.RightDoor ? rdOpen : rdClose);
        }

        return 1;
}

function FarmTruckVehicle::onHood(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.HoodTime) > 650)
        {
                %obj.HoodTime = %time;
                %obj.Hood = !%obj.Hood;
                %obj.playThread(0, %obj.Hood ? hOpen : hClose);
        }

        return 1;
}

function FarmTruckVehicle::onTailgate(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.TailgateTime) > 650)
        {
                %obj.TailgateTime = %time;
                %obj.Tailgate = !%obj.Tailgate;
                %obj.playThread(0, %obj.Tailgate ? tgOpen : tgClose);
        }

        return 1;
}